%define with_tboot 1
%define enable_tnc 1

Summary: TCG Platform Trust Service (PTS)
Name: openpts
Version: 0.2.6

Release: 2%{?dist}
License: CPL
Url: http://sourceforge.jp/projects/openpts/
Source0: http://sourceforge.jp/projects/openpts/downloads/54410/openpts-%{version}.tar.gz

Group: Applications/System
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  autoconf automake libtool trousers-devel openssl-devel 
BuildRequires: libxml2-devel libuuid-devel gettext-devel
Requires:       trousers >= 0.3.6, openssl >= 1.0.0, libxml2, libuuid
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts
Requires(postun): initscripts

%if %{enable_tnc}
BuildRequires: libtnc-devel
Requires:      libtnc
%endif

%if %{with_tboot}
Requires:      tboot
%endif

# seems like coding errors
Patch1: bugs.patch
# To resolve inconsistency in its file name in /var/lock/subsys/
Patch2: init-script.patch
Patch3: openpts-zlib.patch

%description
OpenPTS is an open-source package of Platform Trust Service (PTS)
defined by Trusted Computing Group (TCG). Trusted Computing is a set of
specifications set forth by the Trusted Computing Group (TCG).

%prep
%setup -q -n openpts-%{version}

%patch1 -p1
%patch2 -p1
%patch3 -p1

%build
sh bootstrap.sh
%configure --disable-static --prefix=/usr --libdir=%{_libdir} --with-tss --with-aru \
%if %{with_tboot}
  --with-tboot \
%endif
%if %{enable_tnc}
  --enable-tnc
%endif
#fails due to -lopenpts in src/Makefile.am
#make %{?_smp_mflags}
make

%install
rm -rf $RPM_BUILD_ROOT

#mkdir -p ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}/%{_initddir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}
cp -p dist/fedora.initrd.ptsc ${RPM_BUILD_ROOT}/%{_initddir}/ptsc
cp -p dist/ptsc.conf.in ${RPM_BUILD_ROOT}/%{_sysconfdir}/ptsc.conf
cp -p dist/ptsv.conf.in ${RPM_BUILD_ROOT}/%{_sysconfdir}/ptsv.conf
mkdir -p ${RPM_BUILD_ROOT}/%{_prefix}/share/openpts/models
cp -p models/*.uml ${RPM_BUILD_ROOT}/%{_prefix}/share/openpts/models/
mkdir -p $RPM_BUILD_ROOT/%{_var}/lib/openpts


mkdir -p ${RPM_BUILD_ROOT}/%{_prefix}/share/openpts/tpm_emulator
cp dist/tpm_emulator/README.rhel ${RPM_BUILD_ROOT}/%{_prefix}/share/openpts/tpm_emulator/README
cp dist/tpm_emulator/binary_bios_measurements ${RPM_BUILD_ROOT}/%{_prefix}/share/openpts/tpm_emulator/
cp dist/tpm_emulator/tcsd ${RPM_BUILD_ROOT}/%{_prefix}/share/openpts/tpm_emulator/

%if %{with_tboot}
mkdir -p ${RPM_BUILD_ROOT}/%{_prefix}/share/openpts/tboot
cp dist/tboot/README.fedora15 ${RPM_BUILD_ROOT}/%{_prefix}/share/openpts/tboot/README
cp dist/tboot/ptsc.conf.fedora15 ${RPM_BUILD_ROOT}/%{_prefix}/share/openpts/tboot/ptsc.conf
cp dist/tboot/tcsd.conf.fedora15 ${RPM_BUILD_ROOT}/%{_prefix}/share/openpts/tboot/tcsd.conf
cp dist/tboot/tcsd.fedora15 ${RPM_BUILD_ROOT}/%{_prefix}/share/openpts/tboot/tcsd
%endif

make install DESTDIR=${RPM_BUILD_ROOT} INSTALL='install -p'

%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%pre
getent group ptsc >/dev/null || groupadd -r ptsc

%files -f %{name}.lang
%defattr(-,root,root,-)
%doc LICENSE README ChangeLog doc/*.eps
%attr(755, root, root) %{_sbindir}/ptsc
%attr(755, root, root) %{_bindir}/openpts
%attr(755, root, root) %{_bindir}/uml2dot
#%attr(755, root, root) %{_bindir}/iml2aide
%attr(755, root, root) %{_bindir}/tpm_createkey
%attr(755, root, root) %{_bindir}/tpm_readpcr
%attr(755, root, root) %{_bindir}/tpm_extendpcr
%attr(755, root, root) %{_bindir}/iml2text
%attr(755, root, root) %{_bindir}/ir2text
%attr(755, root, root) %{_bindir}/rm2dot
%if %{with_tboot}
%attr(755, root, root) %{_bindir}/tboot2iml
%{_prefix}/share/openpts/tboot/*
%attr(755,root,root) %dir %{_prefix}/share/openpts/tboot
%endif
%{_libdir}/libopenpts.la
%{_libdir}/libopenpts*.so
%if %{enable_tnc}
%{_libdir}/libopenpts_imc.la
%{_libdir}/libopenpts_imc.so*
%{_libdir}/libopenpts_imv.la
%{_libdir}/libopenpts_imv.so*
%endif
%{_prefix}/share/openpts/models/*uml
%{_prefix}/share/openpts/tpm_emulator/*
%attr(755,root,root) %dir %{_prefix}/share/openpts
%attr(755,root,root) %dir %{_prefix}/share/openpts/models
%attr(755,root,root) %dir %{_prefix}/share/openpts/tpm_emulator
%attr(755,root,root) %dir %{_var}/lib/openpts
%attr(0640, root, ptsc) %config(noreplace) %{_sysconfdir}/ptsc.conf
%attr(0640, root, ptsc) %config(noreplace) %{_sysconfdir}/ptsv.conf
%{_mandir}/man5/*
%{_mandir}/man8/*
# Fedora
%{_initddir}/ptsc

# following sections need to be fixed
#%preun
#if [ $1 = 0 ]; then
#        /sbin/service ptsc stop || :
#        /sbin/chkconfig --del ptsc
#fi

%post
/sbin/ldconfig
#/sbin/chkconfig --add ptsc || :

%postun
/sbin/ldconfig
#if [ $1 -ge 1 ] ; then
#        /sbin/service ptsc condrestart 2>&1 > /dev/null || :
#fi

%changelog
* Mon Jan 9 2012 Avesh Agarwal <avagarwa@redhat.com> - 0.2.6-2
- Fixed explicit linking of zlib

* Mon Jan 9 2012 Avesh Agarwal <avagarwa@redhat.com> - 0.2.6-1
- New upstream release 0.2.6
- Removed aide support
- Added ARU support
- Updated spec files
- Modified patches as per new release

* Mon Aug 15 2011 Kalev Lember <kalevlember@gmail.com> - 0.2.5-2
- Rebuilt for rpm bug #728707

* Wed Jul 20 2011 Avesh Agarwal <avagarwa@redhat.com> - 0.2.5-1
- New upstream release 0.2.5
- Fixed spec file and updated local patches

* Tue Jun 7 2011 Avesh Agarwal <avagarwa@redhat.com> - 0.2.4-1
- Initial build on F16
- Latest upstream release 0.2.4
- Enabled support for tnc and tboot
- Upstream changes: ptscd to ptsc, and ptscd.conf to ptsc.conf
- Fixed cleaning of tpm_emaulator and tboot dirs upon uninstall
- Many changes to spec file due to enabling of tnc and tboot
- Fixed local patches

* Fri Apr 15 2011 Avesh Agarwal <avagarwa@redhat.com> - 0.2.3-3
- committed files in fedora and did initial build

* Wed Apr 13 2011 Avesh Agarwal <avagarwa@redhat.com> - 0.2.3-2
- Fixed spec file issues found during package review 
  https://bugzilla.redhat.com/show_bug.cgi?id=691818

* Mon Mar 28 2011 Avesh Agarwal <avagarwa@redhat.com> - 0.2.3-1
- Initial fedora packaging
- Added patch for fixing compile errors
- fixed init script inconsistency issue related 
  to its /var/lock/subsys file
